# with open('/Users/bob/Desktop/old.bin', 'rb') as f:
#     old_data = f.read()

def extract_lav(src_file, header=b"LAV" + bytes([0x12])):
    extract_data(src_file, header=header, ext="lav", expected_page=1)


def extract_flm(src_file, header=b"FLM" + bytes([0x10])):
    extract_data(src_file, header=header, ext="flm", expected_page=26)


def extract_data(src_file, header, ext, expected_page=26):
    with open(src_file, 'rb') as infile:
        whole_data = infile.read()
        print(f"{len(whole_data) = }")
        start = None
        index = whole_data.find(header, start)
        print(f"index: {index}")

        while index != -1:
            current_section = b''
            section_start = index
            page = 0
            while True:
                if section_start >= len(whole_data):
                    break
                real_data = whole_data[section_start:section_start + 512]
                what_ever_data = whole_data[section_start + 512:section_start + 512 + 16]
                print(f"{what_ever_data.hex()} at {section_start + 512}")
                section_start += 512 + 16
                current_section += real_data

                if not what_ever_data.endswith(bytes([0xff] * 8)):
                    if page < expected_page:
                        page += 1
                    else:

                        # if expect_size is not None and section_start < len(whole_data):
                        #     if len(current_section) < expect_size:
                        #         print("Ignore ending, size not enough")
                        #         continue
                        with open(f"/Users/bob/Desktop/diff/{index}.{ext}", 'wb') as f:
                            f.write(current_section)
                        break
            start = section_start + 1
            index = whole_data.find(header, start)
            print(f"index: {index}")


# Use the function
extract_lav('/Users/bob/Desktop/old.bin')
# extract_flm('/Users/bob/Desktop/old.bin')

# extract_test('/Users/bob/Desktop/new.bin')

# with open('/Users/bob/Desktop/new.bin', 'rb') as f:
#     new_data = f.read()

# print(f"{len(old_data) = },  {len(new_data) = }")

# assert len(old_data) == len(new_data)

# last_diff_index = -100

# current_diff_file = None

# for i in range(len(old_data)):
#     old_byte = old_data[i]
#     new_byte = new_data[i]
#     if old_byte != new_byte:
#         if i != last_diff_index + 1:
#             if current_diff_file:
#                 current_diff_file.close()
#             current_diff_file = open(f"/Users/bob/Desktop/diff/{i}.lav", "wb")
#         current_diff_file.write(new_byte.to_bytes(1, 'big'))
#         last_diff_index = i
